game={}
sh=sh-40
function game.load()
sx,sy=math.ceil(sw/32),math.ceil(sh/32)
mx,my=sw/16,sh/16-1
shake={}
for i=1,5 do
shake[i]={x=sx-i,y=sy}
end
apple={}
apple[1]={x=math.max(2,math.random(mx-1)),y=math.max(2,math.random(my-1))}
dir='r'
time=0
speed=0.2
score=0
to_spawn=0
object={}
to_wall=0
spawn_time=0
norm_spawn_time=10
sapple={x=-1,y=-1}
appleb=false
game_over=false
over_time=0
end
function game.update(dt)
if not game_over then
time=time+dt
if time>speed then
  run(can_eat())
  time=0
end
if to_spawn==10 then
  to_spawn=0
  spawn_time=norm_spawn_time
  sapple=spawn_random()
  appleb=true
end
if appleb then
if spawn_time<0 then
  sapple={x=0,y=0}
  appleb=false
end
spawn_time=spawn_time-dt
end
else
over_time=over_time-dt
end
end
function game.draw()
love.graphics.setColor(255, 255, 255, 255)
love.graphics.translate(0,40)
love.graphics.rectangle('line',0,0,mx*16,(my+1)*16)
for i=1,#shake do
  if i==1 then
      love.graphics.setColor(0, 190, 0, 255)
    love.graphics.rectangle('line',shake[i].x*16,shake[i].y*16,16,16)
  else
    love.graphics.setColor(0, 190, 0, 255)
    love.graphics.rectangle('fill',shake[i].x*16,shake[i].y*16,16,16)
  end
end
for i=1,#apple do
  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.circle('line',apple[i].x*16+8,apple[i].y*16+8,7,10)
end
for i=1,#object do
  love.graphics.setColor(255, 255, 255)
  love.graphics.circle('line',object[i].x*16+8,object[i].y*16+8,7,10)
  love.graphics.setColor(255, 0, 0, 255)
  love.graphics.rectangle('line',object[i].x*16,object[i].y*16,16,16)
  love.graphics.setColor(255, 255, 255)
end
if appleb then
    love.graphics.setColor(255, 255, 0, 255)
    love.graphics.circle('fill',sapple.x*16+8,sapple.y*16+8,7,10) end
love.graphics.translate(0,-40)
love.graphics.setColor(255, 255, 255, 255)
if not game_over then
love.graphics.print('Score:'..score,0,0)
love.graphics.print('Speed:'..speed,0,20)
love.graphics.print('To Super:'..10-to_spawn,90,0)
if appleb then
  love.graphics.print('Time:',90,20)
  love.graphics.rectangle('line',130,22,40,14)
  love.graphics.rectangle('fill',130,22,40*(spawn_time/norm_spawn_time),14)
end
love.graphics.print('Wall:'..4-to_wall,180,0)
love.graphics.rectangle('line',220,2,40,14)
love.graphics.rectangle('fill',220,2,40*(to_wall/4),14)
elseif over_time>0 then
love.graphics.printf("Game Over!",sw/2-100,5,100,"center",0,2,2)
else
    state="over"
end
end
function game.keypressed(key)
  if (key=='up' or key=='w') and dir~='d' then dir='u' end
  if (key=='down' or key=='s') and dir~='u' then dir='d' end
  if (key=='left' or key=='a') and dir~='r' then dir='l' end
  if (key=='right' or key=='d') and dir~='l' then dir='r' end
end
function cheak_run(a,b)
ok=true
for i=2,#shake do
  if shake[i].x==shake[1].x+a and shake[i].y==shake[1].y+b then
    ok=false
  end
end
for i=1,#object do
	if shake[1].x+a==object[i].x and shake[1].y+b==object[i].y then
		ok=false
	end
end
if not ok then
game_over=true
over_time=2
end
return ok
end
function can_eat()
ok=true
if dir=='r' then a,b=1,0 end
if dir=='l' then a,b=-1,0 end
if dir=='u' then a,b=0,-1 end
if dir=='d' then a,b=0,1 end
for i=1,#apple do
  if shake[1].x+a==apple[i].x and shake[1].y+b==apple[i].y then
    table.remove(apple,i)
    table.insert(apple,1,spawn_random())
    score=score+1
    if speed >= 0.10 then
        speed = speed - 0.01
    end
    to_spawn=to_spawn+1
	  to_wall=to_wall+1
    ok=false
  end
end
if shake[1].x+a==sapple.x and shake[1].y+b==sapple.y then appleb,ok,sapple,score,to_wall=false,false,{x=-1,y=-1},score+5,to_wall+1 end
return ok
end
function run(b)
  need=false
  if dir=='r' and cheak_run(1,0) then
    table.insert(shake,1,{x=g(shake[1].x+1,100),y=g(100,shake[1].y)})
    need=true
  end
  if dir=='l' and cheak_run(-1,0) then
    table.insert(shake,1,{x=g(shake[1].x-1,100),y=g(100,shake[1].y)})
    need=true
  end
  if dir=='u' and cheak_run(0,-1) then
    table.insert(shake,1,{x=g(shake[1].x,100),y=g(100,shake[1].y-1)})
    need=true
  end
  if dir=='d' and cheak_run(0,1) then
    table.insert(shake,1,{x=g(shake[1].x,100),y=g(100,shake[1].y+1)})
    need=true
  end
  if b and need then
  if to_wall>=4 then
  to_wall=0
  object[#object+1]={x=shake[#shake].x,y=shake[#shake].y}
  end
  table.remove(shake,#shake)
  end
end
function g(a,b)
  if b==100 then
    if a>mx then a=0 end
    if a<0 then a=mx end
    return a
  else
    if b>my then b=0 end
    if b<0 then b=my end
    return b
  end
end
function spawn_random()
ok=false
while not ok do
  ok=true
  x,y=math.max(2,math.random(mx-1)),math.max(2,math.random(my-1))
  for i=1,#shake do
    if shake[i].x==x and shake[i].y==y then
      ok=false
    end
  end
  if ok then
    for i=1,#object do
      if object[i].x==x and object[i].y==y then
        ok=false
      end
    end
  end
  if ok then
    for i=1,#apple do
      if apple[i].x==x and apple[i].y==y then
        ok=false
      end
    end
  end
  if ok then
    if sapple.x==x and sapple.y==y and appleb then
      ok=false
    end
  end
end
return {x=x,y=y}
end
