
local Progressbar = {}

function Progressbar.new()
    local p = get()
    p:setText("")
    p.value = 100
    p.maxValue = 100
    p.w, p.h = 100, 30
    p.color.bar = {0, 220, 110}
    function p:draw()
        love.graphics.setColor(self.color.outline)
        love.graphics.rectangle("line", self.x, self.y, self.w, self.h)
        love.graphics.setColor(self.color.bar)
        love.graphics.rectangle("fill", self.x, self.y, self.value / self.maxValue * self.w, self.h)
    end
    function p:setValue(value)
        self.value = value
    end
    function p:setMax(max)
        self.maxValue = max
    end
    return p
end

return Progressbar
