

function get()
    local template = {
        x = 0,
        y = 0,
        w = 100,
        h = 100,
        text = "null",
        visible = true,
        color = {
            base = {200, 200, 200},
            outline = {180, 180, 180},
            current = {200, 200, 200}
        },
        update = function(dt)

        end,
        draw = function()

        end,
        setPos = function(self, x, y)
            self.x = x or 0
            self.y = y or 0
        end,
        setSize = function(self, width, height)
            self.w = width or 100
            self.h = height or 100
        end,
        setVisible = function(self, bool)
            self.visible = bool
        end,
        setColor = function(self, colortype, color)
            self.color[colortype] = color
        end,
        setText = function(self, text)
            self.text = text
        end
    }
    return template
end

return get
